
''*****************************
''* Rutina grafica reducida   *
''* DEL JUAN CARLIN           *
''*****************************


CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  _stack = ($3000 + $3000 + 100) >> 2   'accomodate display memory and stack

  x_tiles = 16
  y_tiles = 12

  paramcount = 10       
  bitmap_base = $2002
  display_base = $5000


VAR

  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[16]
  word  xs

OBJ

  gr    : "Graphics_r"
  tv    : "tv"

PUB start | k,i,dx,dy,r

  'start tv
  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)


  'init colors
  repeat i from 0 to 63
    colors[i] := $00001010 * (i+4) & $F + $2B060C02

  'init tile screen
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)



  'inicia los graficos
  gr.start
  gr.setup(16, 12, 128, 96, bitmap_base)
  inicio
PUB inicio

 repeat
    'borra
    xs++
    gr.clear

    'lineas   
    gr.colorwidth(3,0)   
    gr.colorwidth(2,1)
    gr.box(-130,-100,60,60)
    gr.colorwidth(0,1)
    gr.box(-127,-95,56,54)    
    gr.colorwidth(1,0)    
    gr.dec(28,183,xs)
    gr.dec(20,183,xs*2) 
    gr.text(4,5,string ("PRUEBA"))
    
     

  'el grafico a la pantalla
  gr.copy(display_base)

     
DAT

tvparams                long    0               'status
                        long    1               'enable
                        long    %001_0101       'pins
                        long    %00001          'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    12              'hx
                        long    1               'vx
                        long    10               'ho
                        long    24               'vo
                        long    0               'broadcast
                        long    0               'auralcog
